



Public Class Form1

    'This program copies or updates files from one source folder to another on an XP platform.
    'Copyright (C) 2007]  Kezmonk (Kenneth W Berendzen)
    '
    'This program is free software: you can redistribute it and/or modify it under the terms of the 
    'GNU General Public License as published by the Free Software Foundation, either version 3 of the 
    'License, or (at your option) any later version. 
    '
    'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
    'without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
    'See the GNU General Public License for more details. 
    '
    'You should have received a copy of the GNU General Public License along with this program. 
    'If not, see <http://www.gnu.org/licenses/>. 


    <System.STAThread()> _
    Public Shared Sub Main()
        System.Windows.Forms.Application.Run(New Form1)
    End Sub 'Main

    '*
    Private contextMenuStrip3 As System.Windows.Forms.ContextMenuStrip
    Friend WithEvents menuItem1 As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents menuItem2 As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents ToolStripSeparator2 As System.Windows.Forms.ToolStripSeparator
    Friend WithEvents notifyIcon1 As System.Windows.Forms.NotifyIcon
    Private alarmtime As System.DateTime
    Private lastupdatetime As System.DateTime
    Private UpdateIntervalDays_ As Int32
    Private UpdateIntervalTimeOfDay_ As String
    Private AutomaticBackupONOFF As String


    '* total files
    Dim totalFilesInRoot As Integer
    Dim changedFiles As Integer
    Dim Abort As Boolean = False
    Dim FolderError As Boolean = True
    Dim OverwriteReadOnlyFiles As Boolean
    Dim ErrorString As String
    Dim RootProtectedSource As Boolean = False
    Dim FileAttributesSOURCE As IO.FileAttributes
    Dim FileAttributesDEST As IO.FileAttributes



    '* Delegate
    'Delegate Sub mySyncDelg(ByVal d As IO.DirectoryInfo, ByVal s As String)
    'Friend mySnycDelgObj As New mySyncDelg(AddressOf SynchronizeDirectory)

    '*event
    Event progressLevel(ByVal v_ As Integer)

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        ' Clean up any components being used.
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose

    Private Sub notifyIcon1_DoubleClick(ByVal Sender As Object, ByVal e As EventArgs) Handles notifyIcon1.DoubleClick
        ' Show the form when the user double clicks on the notify icon.
        Me.Visible = True
        Me.WindowState = FormWindowState.Normal
        Me.ShowInTaskbar = True
        Me.Activate()
    End Sub

    Private Sub menuItem1_Click(ByVal Sender As Object, ByVal e As EventArgs) Handles menuItem1.Click
        ' Close the form, which closes the application. Since there is only one form which should
        ' be open, this will prevent the call when the Set Backup Time is open. Yes, it's a hack.
        If Application.OpenForms.Count = 1 Then Application.Exit()
    End Sub

    Protected Overrides Sub OnResize(ByVal e As System.EventArgs)
        MyBase.OnResize(e)
        If Me.WindowState = FormWindowState.Minimized And My.Settings.AutomaticBackup = 1 Then
            Me.Visible = False
        End If
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        My.Settings.BackupFolder = Me.txtSnydFolder.Text
        My.Settings.RootFolder = Me.txtRootFolder.Text
        My.Settings.alarmtime = alarmtime
        My.Settings.NextUdpate = lastupdatetime
        My.Settings.UpdateIntervalDays = UpdateIntervalDays_
        My.Settings.UpdateIntervalTimeOfDay = UpdateIntervalTimeOfDay_

        '* i dunno, some bug, either mine or theirs
        If My.Settings.location.X < 0 Or My.Settings.location.Y < 0 Then
            Dim loc As System.Drawing.Point
            loc.X = 0
            loc.Y = 0
            My.Settings.location = loc
        End If

    End Sub


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '* copy over my settings to gloabl variables, private scope
        If My.Settings.RootFolder <> "" Then Me.txtRootFolder.Text = My.Settings.RootFolder
        If My.Settings.BackupFolder <> "" Then Me.txtSnydFolder.Text = My.Settings.BackupFolder
        lastupdatetime = My.Settings.NextUdpate
        UpdateIntervalDays_ = My.Settings.UpdateIntervalDays
        UpdateIntervalTimeOfDay_ = My.Settings.UpdateIntervalTimeOfDay
    End Sub

    '* event subroutine
    Sub updateProgressBar(ByVal val As Integer) Handles Me.progressLevel
        If val > 100 Then val = 100
        Me.ProgressBar1.Value = val
    End Sub

    Sub SynchronizeDirectory(ByVal sourceDir As IO.DirectoryInfo, ByVal destDirName As String)

        Dim subDir, destDir As IO.DirectoryInfo
        Dim sourceFile, destFile As IO.FileInfo
        Dim destFileName As String

        '* If there are space errors then the operation is terminal
        '* test if the target directory already exists
        Try
            destDir = New IO.DirectoryInfo(destDirName)
            If destDir.Exists = False Then destDir.Create()

        Catch exsec As Security.SecurityException
            Beep()
            MsgBox(exsec.Message)
            FolderError = True
            GoTo USERCLICKEDSTOP

            'Catch exsp As  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        Catch ex As IO.IOException
            Beep()
            ' MsgBox(ex.GetType.Name)
            MsgBox(ex.Message) ' & " " & System.ComponentModel.TypeDescriptor.GetClassName(ex)
            FolderError = True
            GoTo USERCLICKEDSTOP

        End Try


        '* I am also counting the directories
        changedFiles += 1


        '* work all the files from the source directory
        For Each sourceFile In sourceDir.GetFiles

            Me.lblFileName.Text = sourceFile.Name
            Me.Refresh()

            destFileName = IO.Path.Combine(destDir.FullName, sourceFile.Name)
            If IO.File.Exists(destFileName) = False Then


                '* check to see if the source is write protected, remember it
                Try
                    If InStr(sourceFile.Attributes.ToString, "ReadOnly") > 0 Then
                        'DummyFile.Attributes = sourceFile.Attributes
                        FileAttributesSOURCE = sourceFile.Attributes
                        sourceFile.Attributes = 128
                        RootProtectedSource = True
                    Else
                        RootProtectedSource = False
                    End If


                    sourceFile.CopyTo(destFileName, True)
                    IO.File.SetLastWriteTime(destFileName, sourceFile.LastWriteTime)

                    '* reset the root settings
                    If RootProtectedSource = True Then sourceFile.Attributes = FileAttributesSOURCE

                Catch exsp As InsufficientMemoryException
                    MsgBox("WARNING: No memory on Drive Left!!!!!", MsgBoxStyle.Critical)
                    FolderError = True
                    Exit Sub

                Catch sysex As System.Security.SecurityException
                    '* non-threating errors
                    ErrorString = "You do not have permissions for " & sourceFile.FullName & vbCr

                Catch expath As System.IO.PathTooLongException
                    ErrorString = "Final Path (over 248 chr) too long for: " & destFileName & vbCr

                Catch ex2 As Exception
                    '*non-threating errors
                    ErrorString = "Could not copy " & sourceFile.FullName & " because " & ex2.Message & vbCr



                End Try


            ElseIf sourceFile.LastWriteTime > IO.File.GetLastWriteTime(destFileName) = True Then
                destFile = New IO.FileInfo(destFileName)

                Try

                    '* check to see if the source is write protected, remember it
                    'MsgBox(sourceFile.Attributes.ToString)
                    If InStr(sourceFile.Attributes.ToString, "ReadOnly") > 0 Then
                        FileAttributesSOURCE = sourceFile.Attributes
                        sourceFile.Attributes = 128
                        RootProtectedSource = True
                    Else
                        RootProtectedSource = False
                    End If

                    If InStr(destFile.Attributes.ToString, "ReadOnly") > 0 And OverwriteReadOnlyFiles = True Then
                        FileAttributesDEST = destFile.Attributes
                        destFile.Attributes = 128
                        'RootProtectedDest = True
                        '* change the destination attributes to allow overwrite and reset them
                        sourceFile.CopyTo(destFileName, True)
                        IO.File.SetLastWriteTime(destFileName, sourceFile.LastWriteTime)
                        destFile.Attributes = FileAttributesDEST
                    ElseIf InStr(destFile.Attributes.ToString, "ReadOnly") <= 0 Then
                        '* change the destination attributes to allow overwrite and reset them
                        sourceFile.CopyTo(destFileName, True)
                        IO.File.SetLastWriteTime(destFileName, sourceFile.LastWriteTime)
                        destFile.Attributes = FileAttributesSOURCE
                    End If

                    '* reset the root settings
                    If RootProtectedSource = True Then sourceFile.Attributes = FileAttributesSOURCE


                Catch sysex As System.Security.SecurityException
                    ErrorString = "You do not have permissions for " & sourceFile.FullName & vbCr

                Catch expath As System.IO.PathTooLongException
                    ErrorString = "Final Path (over 248 chr) too long for: " & destFileName & vbCr

                Catch ex2 As Exception
                    ErrorString = "Could not copy " & sourceFile.FullName & " because " & ex2.Message & vbCr

                End Try

            End If


            '*output progress
            changedFiles += 1
            Me.lblFeedBack.Text = "Checked " & changedFiles & " files of " & totalFilesInRoot

            RaiseEvent progressLevel(CType(changedFiles / totalFilesInRoot * 100, Integer))

            '*look for clicking of the cancel button
            Application.DoEvents()
            'Threading.Thread.Sleep(30)
            If Abort = True Then
                FolderError = True '* not really a folder error, but the user stopped the backup for somereason
                GoTo USERCLICKEDSTOP
            End If

        Next




        '* recursive call
        For Each subDir In sourceDir.GetDirectories()
            SynchronizeDirectory(subDir, IO.Path.Combine(destDirName, subDir.Name))
        Next


USERCLICKEDSTOP:
    End Sub

    Private Sub CountAllFilesInRoot(ByVal dir As IO.DirectoryInfo)
        Dim subDir As IO.DirectoryInfo

        totalFilesInRoot += dir.GetFileSystemInfos.LongLength

        '* recursive call
        For Each subDir In dir.GetDirectories()
            CountAllFilesInRoot(subDir)
        Next
    End Sub

    Private Sub RUN_CLICK_MANAGER()
        Dim sourceDir As IO.DirectoryInfo

        If txtRootFolder.Text = "" Or txtSnydFolder.Text = "" Then Exit Sub


        '* check if the source and destination are the same abort
        If txtRootFolder.Text = txtSnydFolder.Text Then
            MsgBox("Error: the source and destination directory are the same!", MsgBoxStyle.Exclamation, "Same Directories")
            Exit Sub
        End If


        '* check root folder
        If Not My.Computer.FileSystem.DirectoryExists(txtRootFolder.Text) Then
            MsgBox("Text in Root Folder box is not a folder or folder does not exist!", MsgBoxStyle.Critical)
            FolderError = True
            Exit Sub
        End If

        '* check sync folder
        Dim ParentFolder As String
        ParentFolder = Mid(txtSnydFolder.Text, 1, InStrRev(txtSnydFolder.Text, "\") - 1)

        If Not My.Computer.FileSystem.DirectoryExists(ParentFolder) Then
            MsgBox("Text in Snyc Folder box is not a folder or folder does not exist!" & vbCr & _
            "If you are trying to make a new folder, it must be made in an exisiting folder first!", MsgBoxStyle.Critical)
            FolderError = True
            Exit Sub
        End If

        '* If the folders are allright we let it pass
        FolderError = False

        '* message
        Me.lblFeedBack.Text = "Please wait, scanning files."
        Me.Refresh()


        '* set the source directory
        sourceDir = New IO.DirectoryInfo(txtRootFolder.Text)


        '* count total number of files
        CountAllFilesInRoot(sourceDir)
        If totalFilesInRoot = 0 Then Exit Sub
        Me.lblFeedBack.Text = ""
        Me.Refresh()

        '* set buttons 
        Me.btnRUN.Enabled = False
        Me.btnSTOP.Enabled = True
        Me.UpdateReadOnlyFilesToolStripMenuItem.Enabled = False
        ErrorString = "" & vbCr

        '* run recursive call
        SynchronizeDirectory(sourceDir, txtSnydFolder.Text)

        '* clean up variables
        Me.btnRUN.Enabled = True
        Me.btnSTOP.Enabled = False
        Abort = False
        totalFilesInRoot = 0
        changedFiles = 0
        RaiseEvent progressLevel(0)
        If Len(ErrorString) > 1 Then MsgBox(ErrorString)
        ErrorString = ""
        Me.lblFeedBack.Text = ""
        Me.lblFileName.Text = ""
        Me.UpdateReadOnlyFilesToolStripMenuItem.Enabled = True
    End Sub
    Private Sub btnRUN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRUN.Click
        RUN_CLICK_MANAGER()
    End Sub

    Private Sub btnSTOP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSTOP.Click
        Abort = True
    End Sub

    Private Sub txtRootFolder_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles txtRootFolder.DragDrop
        Dim dir() As String
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            dir = CType(e.Data.GetData(DataFormats.FileDrop), String())
            If IO.Directory.Exists(dir(0)) Then txtRootFolder.Text = dir(0)
        End If
    End Sub

    Private Sub txtRootFolder_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles txtRootFolder.DragEnter
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Link
        End If
    End Sub

    Private Sub ContextMenuStrip1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ContextMenuStrip1.Click

        Me.FolderBrowserDialog1.ShowDialog()

        If Me.ContextMenuStrip1.SourceControl.Name = txtRootFolder.Name Then
            txtRootFolder.Text = Me.FolderBrowserDialog1.SelectedPath
        ElseIf Me.ContextMenuStrip1.SourceControl.Name = txtSnydFolder.Name Then
            txtSnydFolder.Text = Me.FolderBrowserDialog1.SelectedPath
        End If

    End Sub

    Private Sub txtSnydFolder_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles txtSnydFolder.DragDrop
        Dim dir() As String
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            dir = CType(e.Data.GetData(DataFormats.FileDrop), String())
            If IO.Directory.Exists(dir(0)) Then txtSnydFolder.Text = dir(0)
        End If
    End Sub


    Private Sub txtSnydFolder_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles txtSnydFolder.DragEnter
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Link
        End If
    End Sub


    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        totalFilesInRoot = 0
        changedFiles = 0
        Me.btnSTOP.Enabled = False
        OverwriteReadOnlyFiles = True
        ErrorString = ""

        '"E:\Dokumente und Einstellungen\kenet\Eigene Dateien\Visual Studio 2005\Projects\SnychronizeBackupFolder\SnychronizeBackupFolder\arrow for icon.ico"

        '* add parts for the Icon notification ---

        ' Add any initialization after the InitializeComponent() call.
        Me.components = New System.ComponentModel.Container
        Me.contextMenuStrip3 = New System.Windows.Forms.ContextMenuStrip
        Me.menuItem1 = New System.Windows.Forms.ToolStripMenuItem
        Me.menuItem2 = New System.Windows.Forms.ToolStripMenuItem
        Me.ToolStripSeparator2 = New System.Windows.Forms.ToolStripSeparator
        Me.ToolStripSeparator2.Name = "ToolStripSeparator2"
        Me.ToolStripSeparator2.Size = New System.Drawing.Size(230, 6)
        Me.menuItem2.Text = "Set A&utomatic Backup Time"
        alarmtime = My.Settings.alarmtime 'since NEW comes before LOAD
        Me.menuItem2.ToolTipText = "Next Update at " & alarmtime.ToString
        Me.menuItem1.Text = "E&xit"

        ' Initialize contextMenu1 and add the menuitem object to it
        Me.contextMenuStrip3.Items.AddRange(New System.Windows.Forms.ToolStripItem() _
                            {Me.menuItem2, Me.ToolStripSeparator2, Me.menuItem1})

        ' Create the NotifyIcon.
        Me.notifyIcon1 = New System.Windows.Forms.NotifyIcon(Me.components)

        ' The Icon property sets the icon that will appear
        ' in the systray for this application.
        notifyIcon1.Icon = New Icon(My.Resources.arrow_for_icon, My.Resources.arrow_for_icon.Size) 'New Icon("E:\Dokumente und Einstellungen\kenet\Eigene Dateien\Visual Studio 2005\Projects\SnychronizeBackupFolder\SnychronizeBackupFolder\arrow for icon.ico")

        ' The ContextMenu property sets the menu that will
        ' appear when the systray icon is right clicked.
        notifyIcon1.ContextMenuStrip = Me.contextMenuStrip3

        ' The Text property sets the text that will be displayed,
        ' in a tooltip, when the mouse hovers over the systray icon.
        notifyIcon1.Text = "Synchronization Backup Folder"
        notifyIcon1.Visible = True


        '* this is only changed if the user had done so before
        If My.Settings.AutomaticBackup = 1 Then
            RunAutomaticallyOFFToolStripMenuItem.Text = "Run Automatically              ON"
            Me.Timer1.Enabled = True
            RunInBackground()
        Else
            Me.WindowState = FormWindowState.Normal
            Me.Visible = True
        End If

    End Sub

    Sub RunInBackground()
        Me.Visible = False
        ShowInTaskbar = False
        Me.WindowState = FormWindowState.Minimized
    End Sub

    Private Sub ViewLiscenceToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ViewLiscenceToolStripMenuItem.Click
        MsgBox("SynchronizeBackupFolder  Copyright (C) 2007 Kezmonk (Kenneth W Berendzen)" & vbCr & _
               "This program comes with ABSOLUTELY NO WARRANTY! " & vbCr & _
               "This software is 'AS IS' and comes with not guarantee or warranty for use or mis-use of this product." & vbCr & _
               "This software is covered by the GNU GENERAL PUBLIC LICENSE" & vbCr & _
               "To view it please goto: see <http://www.gnu.org/licenses/>." & vbCr & _
               "This is free software, and you are welcome to redistribute it under certain conditions. " & vbCr _
         , MsgBoxStyle.Information, "SnychronizeBackupFolder License")
    End Sub

    Private Sub SetOpacityToolStripMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles SetOpacityToolStripMenuItem.Click
        Dim op As String
        op = InputBox("Set the Opacity 10 to 100%", "Opacity", 100, , )
        If IsNumeric(op) Then
            If op >= 10 And op <= 100 Then
                Me.Opacity = op / 100
            End If
        End If
    End Sub

    Private Sub UpdateReadOnlyFilesToolStripMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles UpdateReadOnlyFilesToolStripMenuItem.Click
        If OverwriteReadOnlyFiles = True Then
            OverwriteReadOnlyFiles = False
            UpdateReadOnlyFilesToolStripMenuItem.Text = "Update ReadOnly files      OFF"
        ElseIf OverwriteReadOnlyFiles = False Then
            OverwriteReadOnlyFiles = True
            UpdateReadOnlyFilesToolStripMenuItem.Text = "Update ReadOnly files      ON"
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Beep() '* for debugging only
        Beep()
        If DateTime.Now.CompareTo(My.Settings.alarmtime) >= 0 Then

            '* show the form the user knows its active
            Me.Visible = True
            Me.WindowState = FormWindowState.Normal

            '* copy to backup folder
            RUN_CLICK_MANAGER()


            ' *hide again if everything went well
            If FolderError = False Then

                '* pause for 2 seconds
                System.Threading.Thread.Sleep(1000)

                '* adjust next alarmtime
                alarmtime = alarmtime.AddDays(UpdateIntervalDays_)

                '* send to the hiding state
                Me.WindowState = FormWindowState.Minimized
                Me.Visible = False

            Else
                ToggleAutoBackup()
                MsgBox("TIMER DEACTIVATED!! Check Settings, Check Folders!!!!", MsgBoxStyle.Critical)
            End If

        End If

    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub

    Private Sub ToggleAutoBackup()
        If My.Settings.AutomaticBackup = 1 Then
            My.Settings.AutomaticBackup = 0
            RunAutomaticallyOFFToolStripMenuItem.Text = "Run Automatically              OFF"
            Me.Timer1.Enabled = False

        ElseIf My.Settings.AutomaticBackup = 0 Then
            My.Settings.AutomaticBackup = 1
            RunAutomaticallyOFFToolStripMenuItem.Text = "Run Automatically              ON"
            Me.Timer1.Enabled = True
        End If
    End Sub
    Private Sub RunAutomaticallyOFFToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RunAutomaticallyOFFToolStripMenuItem.Click
        ToggleAutoBackup()
    End Sub

    Private Sub menuItem2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles menuItem2.Click
        '* this menu item is to set the time
        'If My.Settings.UpdateIntervalDays < 0 Then My.Settings.UpdateIntervalDays = 7 '* defalut is 1 week
        'If My.Settings.UpdateIntervalTimeOfDay = "" Then My.Settings.UpdateIntervalTimeOfDay = "12:00"
        Dim inputData As String
        Dim dayint As Int32 = -1
        Dim exitquestion As Int32
        Dim time As Date
        Dim newtime As Date


        Do
            Do
                If DateTime.Now.CompareTo(My.Settings.alarmtime) >= 0 Then
                    inputData = InputBox("The next backup time is not set." & vbCr & vbCr & "Please enter backup Interval in Days.", "Backup Interval in Days", 7)
                Else
                    inputData = InputBox("The next backup is " & alarmtime.ToString & vbCr & vbCr & "Please enter backup Interval in Days.", "Backup Interval in Days", 7)
                End If
                If IsError(inputData) Then
                    Beep()
                    MsgBox("Please enter only a number from 1 to 99", MsgBoxStyle.Exclamation)
                ElseIf IsNumeric(inputData) Then
                    dayint = CInt(inputData)
                Else
                    Beep()
                    MsgBox("Please enter only a number from 1 to 99", MsgBoxStyle.Exclamation)
                End If
            Loop While dayint < 1 Or dayint > 99

            '* set global variables
            UpdateIntervalDays_ = dayint
            alarmtime = Now.AddDays(dayint)

            Do
                inputData = InputBox("Enter a time of Day for the Automatic Backup", "Time of Day", "12:00")
                If IsDate(inputData) And InStr(inputData, ":", CompareMethod.Binary) Then
                    time = inputData
                    newtime = New Date(alarmtime.Year, alarmtime.Month, alarmtime.Day, time.Hour, time.Minute, time.Second)
                    alarmtime = newtime            
                Else
                    Beep()
                    MsgBox("You need to enter an appropiate time.", MsgBoxStyle.Exclamation)
                End If

            Loop While Not IsDate(inputData) And Not InStr(inputData, ":", CompareMethod.Binary)

            exitquestion = MsgBox("The next backup is every " & UpdateIntervalDays_ & " days." & vbCr & "Next update at " & alarmtime.ToString & vbCr & vbCr & "Is everything correct?", MsgBoxStyle.YesNo, "Exit Quetion")
        Loop While exitquestion <> 6




    End Sub
End Class
